<?php
// FILENAME: flatpress-sitemap-generator.php
// By: Vincent L'Eclsue
// http://www.vincentlecluse.com
// ====================================
//user editable part
	$sitemap_name = 'sitemap.xml'; //The sitemap name
	
	//End user editable
	
	// php code that generates sitemaps and sitemap index files
	     // PHP google_sitemap Generator
	    require_once( "pinggooglesitemaps.php" );
	    require_once( "google_sitemap.class.php" ); 
	    require_once("defaults.php");
	    require_once(INCLUDES_DIR.'includes.php');
	    $fp = fopen("sitemap.xml","w");
	    $website_url = BLOG_BASEURL; 
	    if (function_exists('system_init')) {
	    	system_init();
	    } else {
	    	plugin_loadall();
	    }
	 
	
	    error_reporting(E_ALL);
	 
	      //Regular pages
		$cats[] = array(
			"loc" => $website_url,
			"changefreq" => "daily",
		);
	 
	 /****************** This part was suggested by NoWhereMan  *************************/
	 $o = new FPDB_Query(array('start'=>0, 'count'=>-1, 'fullparse'=>0),0);
		while($o->hasmore()) {
		list($id, $entry) = $o->getEntry();
		$link = get_permalink($id);
	//	echo "$link<br>";
		$cats[] = array(
			"loc" => $link,
			"changefreq" => "yearly",
		);
		 
			// $entry['subject'] etc etc;
			// notice that with fullparse = 0 you'll get only subject, date, id;
			// set it to =1 if you want categories and author as well
		}
	/***********************************************************************************/
	
	 
	 
	 
	
	    $site_map_container =& new google_sitemap();
	
	    for ( $i=0; $i < count( $cats ); $i++ )
	    {
	        $value = $cats[ $i ];
	
	        $site_map_item =& new google_sitemap_item( $value[ 'loc' ], "", $value[ 'changefreq' ], "0.8" );
	
	        $site_map_container->add_item( $site_map_item );
	    }
	
	    //header( "Content-type: application/xml; charset=\"".$site_map_container->charset . "\"", true );
	    //header( 'Pragma: no-cache' );
	
	    //print $site_map_container->build();
	    fputs($fp,$site_map_container->build());
	
	// ...
	
	// Once the sitemaps are ready, we ping Google...
	if( 200 === ($status=pingGoogleSitemaps($website_url.$sitemap_name)) )
	   print( "Ping to Google Sitemaps successful.\r\n\r\nStatus code: $status." );
	else
	   print( "Cannot ping/connect to Google Sitemaps.\r\n\r\nStatus code: $status."  );
	
	// end the script.
    
?>